#ifndef MOTIONPOINTH
#define MOTIONPOINTH

#include <coef.h>
#include <quaternion.h>

class CBone;

class CMotionPoint
{
public:
	CMotionPoint();
	~CMotionPoint();

	int InitParams();

	int GetEul( D3DXVECTOR3* dsteul );
	int SetEul( D3DXVECTOR3 srceul );
	int UpdateMatrix( D3DXMATRIX* wmat, D3DXMATRIX* parmat, CBone* srcbone );

	int AddToPrev( CMotionPoint* addmp );
	int AddToNext( CMotionPoint* addmp );
	int LeaveFromChain( int srcmotid = -1, CBone* boneptr = 0 );


private:
	int DestroyObjs();

	int MakeMat( CBone* srcbone );
	int MakeTotalMat( D3DXMATRIX* parmat, CBone* srcbone );
	int MakeWorldMat( D3DXMATRIX* wmat );

public:
	double m_frame;
	D3DXVECTOR3 m_eul;
	CQuaternion m_q;
	D3DXVECTOR3 m_tra;

	CQuaternion m_totalq;//ẻe󂯂Ă]

	D3DXMATRIX m_mat;//ẻe󂯂ĂȂ}gbNX
	D3DXMATRIX m_totalmat;//ẻe󂯂Ă}gbNX
	D3DXMATRIX m_worldmat;//[hϊƐẻe󂯂}gbNX

	CMotionPoint* m_prev;
	CMotionPoint* m_next;
};

#endif